﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PB069.Lecture4.Events
{
    public partial class MainForm : Form
    {

        private Tank uglyTank;
        private Tank niceTank;


        public MainForm()
        {
            InitializeComponent();

            uglyTank = new Tank("M60 Ugly");
            uglyTank.TankHit += new TankHitEventHandler(tank_TankHit);
            uglyTank.TankDestroyed += new TankEventHandler(uglyTank_TankDestroyed);
            uglyTank.Message += tank_MessageSend;

            niceTank = new Tank("M1A1 Abrams");
            niceTank.TankHit += new TankHitEventHandler(tank_TankHit);
            niceTank.TankDestroyed += new TankEventHandler(niceTank_TankDestroyed);
            niceTank.Message += tank_MessageSend;

            AddLineToTextBox("Tanky byly vytvořeny v konstruktoru formuláře.");
        }

        // obsluha událostí tanků

        private void tank_MessageSend(Tank tank, string message)
        {
            AddLineToTextBox(string.Format("{0}: {1}", tank.Name, message));
        }

        private void niceTank_TankDestroyed(Tank tank)
        {
            AddLineToTextBox("Zničil jsi pěkný tank. To nebylo pěkné.");
        }

        private void uglyTank_TankDestroyed(Tank tank)
        {
            AddLineToTextBox("Zničil jsi škaredý tank. Dobrá práce.");
        }

        private void tank_TankHit(Tank tank, int damage)
        {
            AddLineToTextBox(string.Format("Tank {1} byl zasažen, zbývá mu {0} životů", tank.HitPoints, tank.Name));
        }


        // obsluha tlačítek formuláře

        private void shootButton_Click(object sender, EventArgs e)
        {
            uglyTank.TakeHit(40);
        }

        private void shootAtNiceTankButton_Click(object sender, EventArgs e)
        {
            niceTank.TakeHit(40);
        }

        // pomocná metoda pro výpis do textového pole


        public void AddLineToTextBox(string text)
        {
            messagesTextBox.Text += text;
            messagesTextBox.Text += Environment.NewLine;
        }
    }

}
