﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PB069.Lecture4.Events
{
    public class Tank
    {
        public event TankHitEventHandler TankHit;

        public event TankEventHandler TankDestroyed;

        public event Action<Tank, string> Message;


        public string Name { get; private set; }

        public int HitPoints { get; private set; }

        public bool IsAlive
        {
            get { return HitPoints > 0; }
        }


        public Tank(string name)
        {
            Name = name;
            HitPoints = 100;
        }

        public void TakeHit(int damage)
        {
            if(IsAlive)
            {
                if( HitPoints > damage)
                {
                    HitPoints = HitPoints - damage;
                    OnTankHit(damage);
                }
                else
                {
                    OnTankHit(HitPoints);
                    HitPoints = 0;
                    OnTankDestroyed();
                }
            }
            else
            {
                OnMessage("Už je po mě, nech mě už na pokoji. Já už s váma nehraju.");
            }
        }



        protected virtual void OnTankHit(int damage)
        {
            TankHitEventHandler handler = TankHit;
            if (handler != null)
                handler(this, damage);
        }

        protected virtual void OnTankDestroyed()
        {
            TankEventHandler handler = TankDestroyed;
            if (handler != null)
                handler(this);
        }

        protected virtual void OnMessage(string message)
        {
            Action<Tank, string> handler = Message;
            if (handler != null)
                handler(this, message);
        }
    }
}
